/// <reference types="node" />
import { Bot, segment } from 'koishi';
import 'koishi-adapter-onebot';
interface IQQProps {
    access_token: string;
    host: string;
    port: number;
    bot_id: number;
    list(chat: IChat, args: string[], replyfn: (msg: string) => any): void;
    sub(chat: IChat, args: string[], replyfn: (msg: string) => any): void;
    unsub(chat: IChat, args: string[], replyfn: (msg: string) => any): void;
}
export declare const Message: {
    Image: (value: string | ArrayBuffer | Buffer, data?: segment.Data) => string;
    Video: (value: string | ArrayBuffer | Buffer, data?: segment.Data) => string;
    Voice: (value: string | ArrayBuffer | Buffer, data?: segment.Data) => string;
    ellipseBase64: (msg: string) => string;
    separateAttachment: (msg: string) => {
        message: string;
        attachments: string[];
    };
};
export default class {
    private botInfo;
    private app;
    bot: Bot;
    private messageQueues;
    private tempSenders;
    private next;
    private enqueue;
    private getChat;
    private sendToGroup;
    private sendToUser;
    sendTo: (subscriber: IChat, messageChain: string, noErrors?: boolean) => Promise<void>;
    private initBot;
    private listen;
    connect: () => Promise<void>;
    constructor(opt: IQQProps);
}
export {};
